// SPDX-License-Identifier: Unlicense

// Package naive contains naïve implementations of the Bind and Seq combinators.
// The accompanying tests include simple benchmarks comparing their performance.
package naive

import gp "git.codemonkeysoftware.net/b/gigaparsec"

func Bind2[In, Out, T, T2 any](
	p gp.Parser[In, T],
	f func(T) gp.Parser[In, T2],
	f2 func(T2) gp.Parser[In, Out],
) gp.Parser[In, Out] {
	return gp.Bind(gp.Bind(p, f), f2)
}
func Bind3[In, Out, T, T2, T3, T4, T5, T6, T7, T8, T9 any](
	p gp.Parser[In, T],
	f func(T) gp.Parser[In, T2],
	f2 func(T2) gp.Parser[In, T3],
	f3 func(T3) gp.Parser[In, Out],
) gp.Parser[In, Out] {
	return gp.Bind(gp.Bind(gp.Bind(p, f), f2), f3)
}
func Bind4[In, Out, T, T2, T3, T4 any](
	p gp.Parser[In, T],
	f func(T) gp.Parser[In, T2],
	f2 func(T2) gp.Parser[In, T3],
	f3 func(T3) gp.Parser[In, T4],
	f4 func(T4) gp.Parser[In, Out],
) gp.Parser[In, Out] {
	return gp.Bind(gp.Bind(gp.Bind(gp.Bind(p, f), f2), f3), f4)
}
func Bind5[In, Out, T, T2, T3, T4, T5 any](
	p gp.Parser[In, T],
	f func(T) gp.Parser[In, T2],
	f2 func(T2) gp.Parser[In, T3],
	f3 func(T3) gp.Parser[In, T4],
	f4 func(T4) gp.Parser[In, T5],
	f5 func(T5) gp.Parser[In, Out],
) gp.Parser[In, Out] {
	return gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(p, f), f2), f3), f4), f5)
}
func Bind6[In, Out, T, T2, T3, T4, T5, T6 any](
	p gp.Parser[In, T],
	f func(T) gp.Parser[In, T2],
	f2 func(T2) gp.Parser[In, T3],
	f3 func(T3) gp.Parser[In, T4],
	f4 func(T4) gp.Parser[In, T5],
	f5 func(T5) gp.Parser[In, T6],
	f6 func(T6) gp.Parser[In, Out],
) gp.Parser[In, Out] {
	return gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(p, f), f2), f3), f4), f5), f6)
}
func Bind7[In, Out, T, T2, T3, T4, T5, T6, T7 any](
	p gp.Parser[In, T],
	f func(T) gp.Parser[In, T2],
	f2 func(T2) gp.Parser[In, T3],
	f3 func(T3) gp.Parser[In, T4],
	f4 func(T4) gp.Parser[In, T5],
	f5 func(T5) gp.Parser[In, T6],
	f6 func(T6) gp.Parser[In, T7],
	f7 func(T7) gp.Parser[In, Out],
) gp.Parser[In, Out] {
	return gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(p, f), f2), f3), f4), f5), f6), f7)
}
func Bind8[In, Out, T, T2, T3, T4, T5, T6, T7, T8 any](
	p gp.Parser[In, T],
	f func(T) gp.Parser[In, T2],
	f2 func(T2) gp.Parser[In, T3],
	f3 func(T3) gp.Parser[In, T4],
	f4 func(T4) gp.Parser[In, T5],
	f5 func(T5) gp.Parser[In, T6],
	f6 func(T6) gp.Parser[In, T7],
	f7 func(T7) gp.Parser[In, T8],
	f8 func(T8) gp.Parser[In, Out],
) gp.Parser[In, Out] {
	return gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(p, f), f2), f3), f4), f5), f6), f7), f8)
}
func Bind9[In, Out, T, T2, T3, T4, T5, T6, T7, T8, T9 any](
	p gp.Parser[In, T],
	f func(T) gp.Parser[In, T2],
	f2 func(T2) gp.Parser[In, T3],
	f3 func(T3) gp.Parser[In, T4],
	f4 func(T4) gp.Parser[In, T5],
	f5 func(T5) gp.Parser[In, T6],
	f6 func(T6) gp.Parser[In, T7],
	f7 func(T7) gp.Parser[In, T8],
	f8 func(T8) gp.Parser[In, T9],
	f9 func(T9) gp.Parser[In, Out],
) gp.Parser[In, Out] {
	return gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(gp.Bind(p, f), f2), f3), f4), f5), f6), f7), f8), f9)
}
